import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Emergency, EmergencyParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询紧急联系人管理
 */
export async function pageEmergency(params: EmergencyParam) {
  const res = await request.get<ApiResult<PageResult<Emergency>>>(
    MODULES_API_URL + '/booking/emergency/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询紧急联系人管理列表
 */
export async function listEmergency(params?: EmergencyParam) {
  const res = await request.get<ApiResult<Emergency[]>>(
    MODULES_API_URL + '/booking/emergency',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加紧急联系人管理
 */
export async function addEmergency(data: Emergency) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/emergency',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改紧急联系人管理
 */
export async function updateEmergency(data: Emergency) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/emergency',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除紧急联系人管理
 */
export async function removeEmergency(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/emergency/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除紧急联系人管理
 */
export async function removeBatchEmergency(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/emergency/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询紧急联系人管理
 */
export async function getEmergency(id: number) {
  const res = await request.get<ApiResult<Emergency>>(
    MODULES_API_URL + '/booking/emergency/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
